<template>
  <transition name="fade">
  <section v-if="step === 1">
    <h2 class="faseTitle">Fase 1</h2>
    <div class="subjBackground">
      <h2>Semester 1</h2>
      <h3>Gebruikte studiepunten: {{totalF1Sem1}}</h3>

      <div class="subj">
        <one-subject v-for="subject in subjectsSem1Fas1"
                     :key="subject.id" :subj-data="subject"></one-subject>
      </div>
    </div>

    <div class="subjBackground">
      <h2>Semester 2</h2>
      <h3>Gebruikte studiepunten: {{totalF1Sem2}}</h3>

      <div class="subj">
        <one-subject v-for="subject in subjectsSem2Fas1"
                     :key="subject.id" :subj-data="subject"></one-subject>
      </div>
    </div>
  </section>
  </transition>
  <transition name="fade">
  <section v-if="step === 2">
    <h2 class="faseTitle">Fase 2</h2>
    <div class="subjBackground">
      <h2>Semester 1</h2>
      <h3>Gebruikte studiepunten: {{totalF2Sem1}}</h3>

      <div class="subj">
        <one-subject v-for="subject in subjectsSem1Fas2"
                     :key="subject.id" :subj-data="subject"></one-subject>
      </div>
    </div>

    <div class="subjBackground">
      <h2>Semester 2</h2>
      <h3>Gebruikte studiepunten: {{totalF2Sem2}}</h3>

      <div class="subj">
        <one-subject v-for="subject in subjectsSem2Fas2"
                     :key="subject.id" :subj-data="subject"></one-subject>
      </div>
    </div>
  </section>
  </transition>
  <transition name="fade">
  <section v-if="step === 3">
    <h2 class="faseTitle">Fase 3</h2>
    <div class="subjBackground">
      <h2>Semester 1</h2>
      <h3>Gebruikte studiepunten: {{totalF3Sem1}}</h3>

      <div class="subj">
        <one-subject v-for="subject in subjectsSem1Fas3"
                     :key="subject.id" :subj-data="subject"></one-subject>
      </div>
    </div>

    <div class="subjBackground">
      <h2>Semester 2</h2>
      <h3>Gebruikte studiepunten: {{totalF3Sem2}}</h3>

      <div class="subj">
        <one-subject v-for="subject in subjectsSem2Fas3"
                     :key="subject.id" :subj-data="subject"></one-subject>
      </div>
    </div>
  </section>
  </transition>
  <div class="spn">
    <span>{{error}}</span>
  </div>

  <div class="btn">
    <primary-btn
      v-if="step !== 1" @click.prevent="prevStep" class="btnChild" value="Vorige"></primary-btn>
    <primary-btn
      v-if="step !== totalSteps" @click.prevent="nextStep" value="Volgonde"></primary-btn>
    <primary-btn
      v-if="step === 3" @click.prevent="sendData" value="Opslaan"></primary-btn>
  </div>
  <div class="loading" v-show="loading" role="alert">
    <div class="loading-animate"></div>
  </div>
</template>

<script>
import OneSubject from '../molecules/OneSubject.vue';
import PrimaryBtn from '../atoms/PrimaryBtn.vue';
import auth from '../../../store/modules/auth';

export default {
  name: 'AllSubjects',
  components: { PrimaryBtn, OneSubject },
  data() {
    return {
      step: 1,
      totalSteps: 3,
      error: null,
      loading: false,
    };
  },
  /* eslint-disable */
  methods: {
    // eslint-disable-next-line consistent-return
    nextStep() {
      if (this.step === 1) {
        if (this.totalF1Sem1 < 30) {
          this.error = 'Het totaal aantal gebruikte studiepunten voor semester 1 mag niet minder zijn dan 30!';
          return false;
        } if (this.totalF1Sem1 > 33) {
          this.error = null;
          this.error = 'Het totaal aantal gebruikte studiepunten voor semester 1 mag niet meer zijn dan 33!';
          return false;
        }

        if (this.totalF1Sem2 < 30) {
          this.error = 'Het totaal aantal gebruikte studiepunten voor semester 2 mag niet minder zijn dan 30!';
          return false;
        } if (this.totalF1Sem2 > 33) {
          this.error = 'Het totaal aantal gebruikte studiepunten voor semester 2 mag niet meer zijn dan 33!';
          return false;
        }
      }

      if (this.step === 2) {
        if (this.totalF2Sem1 < 30) {
          this.error = null;
          this.error = 'Het totaal aantal gebruikte studiepunten voor semester 1 mag niet minder zijn dan 30!';
          return false;
        } if (this.totalF2Sem1 > 33) {
          this.error = null;
          this.error = 'Het totaal aantal gebruikte studiepunten voor semester 1 mag niet meer zijn dan 33!';
          return false;
        }

        if (this.totalF2Sem2 < 30) {
          this.error = null;
          this.error = 'Het totaal aantal gebruikte studiepunten voor semester 2 mag niet minder zijn dan 30!';
          return false;
        } if (this.totalF2Sem2 > 33) {
          this.error = null;
          this.error = 'Het totaal aantal gebruikte studiepunten voor semester 2 mag niet meer zijn dan 33!';
          return false;
        }
      }
      // eslint-disable-next-line no-plusplus
      this.step++;
      // eslint-disable-next-line no-restricted-globals
      window.scrollTo(0, top);
      this.error = null;
    },
    prevStep() {
      // eslint-disable-next-line no-plusplus
      this.step--;
    },
    // eslint-disable-next-line consistent-return
    async sendData() {
      if (this.step === 3) {
        if (this.totalF3Sem1 < 30) {
          this.error = 'Het totaal aantal gebruikte studiepunten voor semester 1 mag niet minder zijn dan 30!';
          return false;
        }
        if (this.totalF3Sem1 > 33) {
          this.error = null;
          this.error = 'Het totaal aantal gebruikte studiepunten voor semester 1 mag niet meer zijn dan 33!';
          return false;
        }

        if (this.totalF3Sem2 < 30) {
          this.error = 'Het totaal aantal gebruikte studiepunten voor semester 2 mag niet minder zijn dan 30!';
          return false;
        }
        if (this.totalF3Sem2 > 33) {
          this.error = 'Het totaal aantal gebruikte studiepunten voor semester 2 mag niet meer zijn dan 33!';
          return false;
        }
        if (!auth.state.user) {
          await this.$router.push({ name: 'Login', query: { redirect: '/trajecten/toevoegen' } });
        } else {
          const trajectroySubjects = [];
          this.loading = true;
          await this.chSubjects.forEach((subject) => trajectroySubjects.push(subject.id));
          try {
            await this.$store.dispatch('crTrajectory', trajectroySubjects);
          } catch (errors) {
            console.log(errors);
          } finally {
            // eslint-disable-next-line max-len
            await this.$store.getters.getChosenSubjects.splice(this.$store.getters.getChosenSubjects);
            this.loading = false;
            await this.$router.push({ name: 'Trajecten' });
          }
        }
      }
    },
  },
  computed: {
    subjects() {
      return this.$store.getters.subjects;
    },
    chSubjects() {
      return this.$store.getters.getChosenSubjects;
    },
    subjectsSem1Fas1() {
      return this.$store.getters.subjects.filter((subject) => parseInt(subject.semester, 8) === 1
        && parseInt(subject.phase, 8) === 1);
    },
    choSubjectsSem1Fas1() {
      return this.chSubjects.filter((subject) => parseInt(subject.semester, 8) === 1
        && parseInt(subject.phase, 8) === 1);
    },
    subjectsSem2Fas1() {
      return this.$store.getters.subjects.filter((subject) => parseInt(subject.semester, 8) === 2
        && parseInt(subject.phase, 8) === 1);
    },
    choSubjectsSem2Fas1() {
      return this.chSubjects.filter((subject) => parseInt(subject.semester, 8) === 2
        && parseInt(subject.phase, 8) === 1);
    },
    totalF1Sem1() {
      const totalSp = [];
      // eslint-disable-next-line no-unused-vars
      Object.entries(this.choSubjectsSem1Fas1).forEach(([key, val]) => {
        totalSp.push(val.credit);
      });
      return totalSp.reduce((total, num) => total + num, 0);
    },
    totalF1Sem2() {
      const totalSp = [];
      // eslint-disable-next-line no-unused-vars
      Object.entries(this.choSubjectsSem2Fas1).forEach(([key, val]) => {
        totalSp.push(val.credit);
      });
      return totalSp.reduce((total, num) => total + num, 0);
    },
    subjectsSem1Fas2() {
      return this.$store.getters.subjects.filter((subject) => parseInt(subject.semester, 8) === 1
        && parseInt(subject.phase, 8) === 2);
    },
    choSubjectsSem1Fas2() {
      return this.chSubjects.filter((subject) => parseInt(subject.semester, 8) === 1
        && parseInt(subject.phase, 8) === 2);
    },
    subjectsSem2Fas2() {
      return this.$store.getters.subjects.filter((subject) => parseInt(subject.semester, 8) === 2
        && parseInt(subject.phase, 8) === 2);
    },
    choSubjectsSem2Fas2() {
      return this.chSubjects.filter((subject) => parseInt(subject.semester, 8) === 2
        && parseInt(subject.phase, 8) === 2);
    },
    totalF2Sem1() {
      const totalSp = [];
      // eslint-disable-next-line no-unused-vars
      Object.entries(this.choSubjectsSem1Fas2).forEach(([key, val]) => {
        totalSp.push(val.credit);
      });
      return totalSp.reduce((total, num) => total + num, 0);
    },
    totalF2Sem2() {
      const totalSp = [];
      // eslint-disable-next-line no-unused-vars
      Object.entries(this.choSubjectsSem2Fas2).forEach(([key, val]) => {
        totalSp.push(val.credit);
      });
      return totalSp.reduce((total, num) => total + num, 0);
    },
    subjectsSem1Fas3() {
      return this.$store.getters.subjects.filter((subject) => parseInt(subject.semester, 8) === 1
        && parseInt(subject.phase, 8) === 3);
    },
    choSubjectsSem1Fas3() {
      return this.chSubjects.filter((subject) => parseInt(subject.semester, 8) === 1
        && parseInt(subject.phase, 8) === 3);
    },
    subjectsSem2Fas3() {
      return this.$store.getters.subjects.filter((subject) => parseInt(subject.semester, 8) === 2
        && parseInt(subject.phase, 8) === 3);
    },
    choSubjectsSem2Fas3() {
      return this.chSubjects.filter((subject) => parseInt(subject.semester, 8) === 2
        && parseInt(subject.phase, 8) === 3);
    },
    totalF3Sem1() {
      const totalSp = [];
      // eslint-disable-next-line no-unused-vars
      Object.entries(this.choSubjectsSem1Fas3).forEach(([key, val]) => {
        totalSp.push(val.credit);
      });
      return totalSp.reduce((total, num) => total + num, 0);
    },
    totalF3Sem2() {
      const totalSp = [];
      // eslint-disable-next-line no-unused-vars
      Object.entries(this.choSubjectsSem2Fas3).forEach(([key, val]) => {
        totalSp.push(val.credit);
      });
      return totalSp.reduce((total, num) => total + num, 0);
    },
    totalAllSubjects() {
      const totalSp = [];
      // eslint-disable-next-line no-unused-vars
      Object.entries(this.chSubjects).forEach(([key, val]) => {
        totalSp.push(val.credit);
      });
      return totalSp.reduce((total, num) => total + num, 0);
    },
  },
  async created() {
    if (this.totalAllSubjects > 179) {
      const trajectroySubjects = [];
      this.loading = true;
      await this.chSubjects.forEach((subject) => trajectroySubjects.push(subject.id));
      try {
        await this.$store.dispatch('crTrajectory', trajectroySubjects);
      } catch (errors) {
        console.log(errors);
      } finally {
        // eslint-disable-next-line max-len
        await this.$store.getters.getChosenSubjects.splice(this.$store.getters.getChosenSubjects);
        this.loading = false;
        await this.$router.push({ name: 'Trajecten' });
      }
    }
  },
};
</script>

<style scoped lang="scss">
.faseTitle{
  font-size: 1.6em;
  padding: 20px 0 5px 10%;
  line-height: 130%;
  font-family: $my-text;
  color: $my-black;
}
.subjBackground+.subjBackground{
  margin-top: -5px;
}
.subjBackground{
  background-color: $my-white;
  width: 80%;
  margin: 0 auto;
  border-radius: 11px;

  h2{
    font-size: 1.6em;
    padding: 20px 0 1px 0;
    margin: 2px 8% 2px 8%;
    line-height: 130%;
    font-family: $my-text;
    color: $my-orange;
  }

  h3{
    font-size: 1.3em;
    padding: 20px 0 10px 0;
    border-bottom: $my-orange solid 1px;
    margin: 2px 8% 2px 8%;
    line-height: 130%;
    font-family: $my-text;
    color: $my-blue;
  }

  .subj{
    display: flex;
    justify-content: space-around;
    flex-wrap: wrap;
    padding: 50px;
  }
}
.btn{
  margin: 30px 10% 50px auto;
  text-align: right;
  .btnChild{
    margin-right: 20px;
  }
}
.spn{
  padding: 20px;
  color: red;
  font-size: 0.8em;
  font-family: $my-text;
  text-align: center;
  line-height: 130%;
}
.loading-animate {
  border: 8px solid #f3f3f3;
  border-radius: 50%;
  border-top: 8px solid $my-blue;
  border-bottom: 8px solid $my-blue;
  width: 60px;
  height: 60px;
  -webkit-animation: spin 2s linear infinite;
  animation: spin 2s linear infinite;
}
.loading {
  display: flex;
  justify-content: center;
  align-items: center;
  position: fixed;
  z-index: 6;
  top: 0;
  left: 0;
  width: 100%;
  height: 100%;
}
@media (max-width: 952px){
  .btnChild{
    margin: 10px 0;
  }
}
.fade-enter-from,
.fade-leave-to{
  opacity: 0;
}
.fade-enter-active,
.fade-leave-active {
  transition: opacity 1s ease;
}
</style>
